/* Generated by wayland-scanner 1.20.0 */

#ifndef KWINFT_OUTPUT_MANAGEMENT_UNSTABLE_V1_SERVER_PROTOCOL_H
#define KWINFT_OUTPUT_MANAGEMENT_UNSTABLE_V1_SERVER_PROTOCOL_H

#include <stdint.h>
#include <stddef.h>
#include "wayland-server.h"

#ifdef  __cplusplus
extern "C" {
#endif

struct wl_client;
struct wl_resource;

/**
 * @page page_kwinft_output_management_unstable_v1 The kwinft_output_management_unstable_v1 protocol
 * protocol to create and apply output configurations
 *
 * @section page_desc_kwinft_output_management_unstable_v1 Description
 *
 * This protocol exposes interfaces to change the configuration of current
 * outputs.
 *
 * Warning! The protocol described in this file is experimental and
 * backward incompatible changes may be made.
 *
 * @section page_ifaces_kwinft_output_management_unstable_v1 Interfaces
 * - @subpage page_iface_zkwinft_output_management_v1 - configuration of server outputs through clients
 * - @subpage page_iface_zkwinft_output_configuration_v1 - configure single output devices
 * @section page_copyright_kwinft_output_management_unstable_v1 Copyright
 * <pre>
 *
 * Copyright © 2015 Sebastian Kügler <sebas@kde.org>
 * Copyright © 2020 Roman Gilg <subdiff@gmail.com>
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 * </pre>
 */
struct zkwinft_output_configuration_v1;
struct zkwinft_output_device_v1;
struct zkwinft_output_management_v1;

#ifndef ZKWINFT_OUTPUT_MANAGEMENT_V1_INTERFACE
#define ZKWINFT_OUTPUT_MANAGEMENT_V1_INTERFACE
/**
 * @page page_iface_zkwinft_output_management_v1 zkwinft_output_management_v1
 * @section page_iface_zkwinft_output_management_v1_desc Description
 *
 * This interface enables clients to set properties of output devices for screen
 * configuration purposes via the server. To this end output devices are referenced
 * by global zkwinft_output_device_v1 objects.
 *
 * output_management (wl_global)
 * --------------------------
 * request:
 * * create_configuration -> output_configuration (wl_resource)
 *
 * output_configuration (wl_resource)
 * --------------------------
 * requests:
 * * enable(output_device, bool)
 * * mode(output_device, mode_id)
 * * transformation(output_device, flag)
 * * position(output_device, x, y)
 * * apply
 *
 * events:
 * * applied
 * * failed
 *
 * The server registers one output_management object as a global object. In order
 * to configure outputs a client requests create_configuration, which provides a
 * resource referencing an output_configuration for one-time configuration. That
 * way the server knows which requests belong together and can group them by that.
 *
 * On the output_configuration object the client calls for each output whether the
 * output should be enabled, which mode should be set (by referencing the mode from
 * the list of announced modes) and the output's global position. Once all outputs
 * are configured that way, the client calls apply.
 * At that point and not earlier the server should try to apply the configuration.
 * If this succeeds the server emits the applied signal, otherwise the failed
 * signal, such that the configuring client is noticed about the success of its
 * configuration request.
 *
 * Through this design the interface enables atomic output configuration changes if
 * internally supported by the server.
 * @section page_iface_zkwinft_output_management_v1_api API
 * See @ref iface_zkwinft_output_management_v1.
 */
/**
 * @defgroup iface_zkwinft_output_management_v1 The zkwinft_output_management_v1 interface
 *
 * This interface enables clients to set properties of output devices for screen
 * configuration purposes via the server. To this end output devices are referenced
 * by global zkwinft_output_device_v1 objects.
 *
 * output_management (wl_global)
 * --------------------------
 * request:
 * * create_configuration -> output_configuration (wl_resource)
 *
 * output_configuration (wl_resource)
 * --------------------------
 * requests:
 * * enable(output_device, bool)
 * * mode(output_device, mode_id)
 * * transformation(output_device, flag)
 * * position(output_device, x, y)
 * * apply
 *
 * events:
 * * applied
 * * failed
 *
 * The server registers one output_management object as a global object. In order
 * to configure outputs a client requests create_configuration, which provides a
 * resource referencing an output_configuration for one-time configuration. That
 * way the server knows which requests belong together and can group them by that.
 *
 * On the output_configuration object the client calls for each output whether the
 * output should be enabled, which mode should be set (by referencing the mode from
 * the list of announced modes) and the output's global position. Once all outputs
 * are configured that way, the client calls apply.
 * At that point and not earlier the server should try to apply the configuration.
 * If this succeeds the server emits the applied signal, otherwise the failed
 * signal, such that the configuring client is noticed about the success of its
 * configuration request.
 *
 * Through this design the interface enables atomic output configuration changes if
 * internally supported by the server.
 */
extern const struct wl_interface zkwinft_output_management_v1_interface;
#endif
#ifndef ZKWINFT_OUTPUT_CONFIGURATION_V1_INTERFACE
#define ZKWINFT_OUTPUT_CONFIGURATION_V1_INTERFACE
/**
 * @page page_iface_zkwinft_output_configuration_v1 zkwinft_output_configuration_v1
 * @section page_iface_zkwinft_output_configuration_v1_desc Description
 *
 * output_configuration is a client-specific resource that can be used to ask
 * the server to apply changes to available output devices.
 *
 * The client receives a list of output devices from the registry. When it wants
 * to apply new settings, it creates a configuration object from the
 * output_management global, writes changes through this object's enable, scale,
 * transform and mode calls. It then asks the server to apply these settings in
 * an atomic fashion, for example through Linux' DRM interface.
 *
 * The server signals back whether the new settings have applied successfully
 * or failed to apply. output_device objects are updated after the changes have been
 * applied to the hardware and before the server side sends the applied event.
 * @section page_iface_zkwinft_output_configuration_v1_api API
 * See @ref iface_zkwinft_output_configuration_v1.
 */
/**
 * @defgroup iface_zkwinft_output_configuration_v1 The zkwinft_output_configuration_v1 interface
 *
 * output_configuration is a client-specific resource that can be used to ask
 * the server to apply changes to available output devices.
 *
 * The client receives a list of output devices from the registry. When it wants
 * to apply new settings, it creates a configuration object from the
 * output_management global, writes changes through this object's enable, scale,
 * transform and mode calls. It then asks the server to apply these settings in
 * an atomic fashion, for example through Linux' DRM interface.
 *
 * The server signals back whether the new settings have applied successfully
 * or failed to apply. output_device objects are updated after the changes have been
 * applied to the hardware and before the server side sends the applied event.
 */
extern const struct wl_interface zkwinft_output_configuration_v1_interface;
#endif

/**
 * @ingroup iface_zkwinft_output_management_v1
 * @struct zkwinft_output_management_v1_interface
 */
struct zkwinft_output_management_v1_interface {
	/**
	 * provide output_configuration object for configuring outputs
	 *
	 * Request an output_configuration object through which the
	 * client can configure output devices.
	 */
	void (*create_configuration)(struct wl_client *client,
				     struct wl_resource *resource,
				     uint32_t id);
};


/**
 * @ingroup iface_zkwinft_output_management_v1
 */
#define ZKWINFT_OUTPUT_MANAGEMENT_V1_CREATE_CONFIGURATION_SINCE_VERSION 1

#ifndef ZKWINFT_OUTPUT_CONFIGURATION_V1_ERROR_ENUM
#define ZKWINFT_OUTPUT_CONFIGURATION_V1_ERROR_ENUM
enum zkwinft_output_configuration_v1_error {
	/**
	 * unallowed value has been requested
	 */
	ZKWINFT_OUTPUT_CONFIGURATION_V1_ERROR_BAD_VALUE = 0,
	/**
	 * 
	 */
	ZKWINFT_OUTPUT_CONFIGURATION_V1_ERROR_ALREADY_APPLIED = 1,
};
#endif /* ZKWINFT_OUTPUT_CONFIGURATION_V1_ERROR_ENUM */

/**
 * @ingroup iface_zkwinft_output_configuration_v1
 * @struct zkwinft_output_configuration_v1_interface
 */
struct zkwinft_output_configuration_v1_interface {
	/**
	 * unbind from the presentation interface
	 *
	 * Informs the server that the client will no longer be using
	 * this protocol object. Existing objects created by this object
	 * are not affected.
	 */
	void (*destroy)(struct wl_client *client,
			struct wl_resource *resource);
	/**
	 * enable or disable an output
	 *
	 * Mark the output as enabled or disabled.
	 * @param output_device output device to be en- or disabled
	 * @param enable 1 to enable or 0 to disable this output
	 */
	void (*enable)(struct wl_client *client,
		       struct wl_resource *resource,
		       struct wl_resource *output_device,
		       int32_t enable);
	/**
	 * switch output device to mode
	 *
	 * Sets the mode for a given output by its mode size (width and
	 * height) and refresh rate.
	 * @param output_device output device this mode change applies to
	 * @param mode_id aspired mode's id
	 */
	void (*mode)(struct wl_client *client,
		     struct wl_resource *resource,
		     struct wl_resource *output_device,
		     int32_t mode_id);
	/**
	 * transform output_device
	 *
	 * Sets the transformation for a given output. This
	 * transformation is applied onto the geometry.
	 *
	 * As an example assume the transform is normal, the mode of the
	 * output is 3840x2160 and the geometry is 1080x1920.
	 *
	 * In this case the geometry can be stretched with factor 1.125 to
	 * 1215x2160 and placed according to the compositor's internal
	 * policy somewhere horizontally on the output.
	 *
	 * But if the transform is set to 90, 270 or the respective flipped
	 * values the geometry can be stretched with factor 2 to 3840x2160
	 * and fill the whole area sideways.
	 * @param output_device output device this transformation change applies to
	 * @param transform transform enum
	 */
	void (*transform)(struct wl_client *client,
			  struct wl_resource *resource,
			  struct wl_resource *output_device,
			  int32_t transform);
	/**
	 * set output geometry in global space
	 *
	 * Set the rectangle this output device maps in compositor space,
	 * where (x,y) describe the top-left corner of the rectangle and
	 * its size is described by width and height.
	 *
	 * When width and height are both set to 0, no new content is
	 * posted to the output what implicitly disables it.
	 *
	 * The x, width and height argument must be non-negative and width
	 * must be 0 if and only if height is 0. Otherwise the bad_value
	 * protocol error is raised.
	 * @param output_device output device this geometry applies to
	 * @param x x position within the global compositor space
	 * @param y y position within the global compositor space
	 * @param width logical width of the output in global compositor space
	 * @param height logical height of the output in global compositor space
	 */
	void (*geometry)(struct wl_client *client,
			 struct wl_resource *resource,
			 struct wl_resource *output_device,
			 wl_fixed_t x,
			 wl_fixed_t y,
			 wl_fixed_t width,
			 wl_fixed_t height);
	/**
	 * apply configuration changes to all output devices
	 *
	 * Asks the server to apply property changes requested through
	 * this output_configuration object to all outputs on the server
	 * side.
	 *
	 * After this request has been issued there will guaranteed either
	 * the applied or the failed event be received but no other request
	 * must be send on this object. The object may only be destroyed
	 * anymore. Otherwise the already_applied protocol error will be
	 * raised.
	 */
	void (*apply)(struct wl_client *client,
		      struct wl_resource *resource);
};

#define ZKWINFT_OUTPUT_CONFIGURATION_V1_APPLIED 0
#define ZKWINFT_OUTPUT_CONFIGURATION_V1_FAILED 1

/**
 * @ingroup iface_zkwinft_output_configuration_v1
 */
#define ZKWINFT_OUTPUT_CONFIGURATION_V1_APPLIED_SINCE_VERSION 1
/**
 * @ingroup iface_zkwinft_output_configuration_v1
 */
#define ZKWINFT_OUTPUT_CONFIGURATION_V1_FAILED_SINCE_VERSION 1

/**
 * @ingroup iface_zkwinft_output_configuration_v1
 */
#define ZKWINFT_OUTPUT_CONFIGURATION_V1_DESTROY_SINCE_VERSION 1
/**
 * @ingroup iface_zkwinft_output_configuration_v1
 */
#define ZKWINFT_OUTPUT_CONFIGURATION_V1_ENABLE_SINCE_VERSION 1
/**
 * @ingroup iface_zkwinft_output_configuration_v1
 */
#define ZKWINFT_OUTPUT_CONFIGURATION_V1_MODE_SINCE_VERSION 1
/**
 * @ingroup iface_zkwinft_output_configuration_v1
 */
#define ZKWINFT_OUTPUT_CONFIGURATION_V1_TRANSFORM_SINCE_VERSION 1
/**
 * @ingroup iface_zkwinft_output_configuration_v1
 */
#define ZKWINFT_OUTPUT_CONFIGURATION_V1_GEOMETRY_SINCE_VERSION 1
/**
 * @ingroup iface_zkwinft_output_configuration_v1
 */
#define ZKWINFT_OUTPUT_CONFIGURATION_V1_APPLY_SINCE_VERSION 1

/**
 * @ingroup iface_zkwinft_output_configuration_v1
 * Sends an applied event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
zkwinft_output_configuration_v1_send_applied(struct wl_resource *resource_)
{
	wl_resource_post_event(resource_, ZKWINFT_OUTPUT_CONFIGURATION_V1_APPLIED);
}

/**
 * @ingroup iface_zkwinft_output_configuration_v1
 * Sends an failed event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
zkwinft_output_configuration_v1_send_failed(struct wl_resource *resource_)
{
	wl_resource_post_event(resource_, ZKWINFT_OUTPUT_CONFIGURATION_V1_FAILED);
}

#ifdef  __cplusplus
}
#endif

#endif
